# This file is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as 
# published by the Free Software Foundation here:
# (http://www.gnu.org/licenses/gpl-2.0.html)
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

export SRCPKG = ncurses
export DEPENDS = dash,glibc
export ARCH = x86_64
export URL = https://www.gnu.org/software/ncurses/
REPO = core
BRIEF = Library and tools for terminal handling
DESC = The Ncurses (new curses) library is a free software emulation of \
curses in System V Release 4.0, and more.
SLVER = 3

ARCHIVE := $(PWD)/SRC/$(shell ls SRC|egrep '(bz2|gz|tar|xz)$$'|tail -1)
TYPE := $(shell file -ib $(ARCHIVE)|cut -d';' -f1|tr -d '\n')
SRCDIR := $(shell tar -tf $(ARCHIVE)|head -1|sed 's/\/.*//')
PATCHDIR := $(PWD)/SRC/patches
export VERSION := $(shell echo $(SRCDIR)|egrep -o '\-[0-9].*'| \
	sed 's/^-//')-$(SLVER)

DEV := $(PWD)/ncurses-dev
DEVROOT := $(DEV)/ROOT

include /usr/share/sl/Makefile.snaplinux

$(SRCDIR)/configure: $(ARCHIVE)
	@if [ '$(TYPE)' == 'application/x-bzip2' ]; then \
		tar -jxf $(ARCHIVE); \
	elif [ '$(TYPE)' == 'application/x-gzip' ]; then \
		tar -zxf $(ARCHIVE); \
	elif [ '$(TYPE)' == 'application/x-tar' ]; then \
		tar -xf $(ARCHIVE); \
	elif [ '$(TYPE)' == 'application/x-xz' ]; then \
		tar -xf $(ARCHIVE); \
	else \
		echo 'Unable to determine archive type'; \
		exit 1; \
	fi
	@touch $(SRCDIR)/configure

$(SRCDIR)/config.log: $(SRCDIR)/configure
	@cd $(SRCDIR) && \
	for patch in `find $(PATCHDIR) -name \*.patch|sort`; do \
		patch --verbose -Np1 -i $$patch; \
	done
	@cd $(SRCDIR); \
	./configure \
		--prefix=/usr \
		--mandir=/usr/share/man \
		--with-shared \
		--without-debug \
		--without-normal \
		--enable-pc-files \
		--enable-widec \
		--program-prefix='' \
		--build=x86_64-snap-linux-gnu \
		--host=x86_64-snap-linux-gnu \
		--target=x86_64-snap-linux-gnu

$(SRCDIR)/objects/cursesmain.o: $(SRCDIR)/config.log
	@cd $(SRCDIR) && make

$(ROOT): $(SRCDIR)/objects/cursesmain.o
	@if [ -d $(ROOT) ]; then \
		touch $(ROOT); \
	else \
		mkdir -v $(ROOT); \
	fi

	@cd $(SRCDIR) && make install DESTDIR=$(ROOT) && \
	install -v -d -m 755 $(ROOT)/lib && \
	mv -v $(ROOT)/usr/lib/libncursesw.so.[0-9]* $(ROOT)/lib && \
	ln -sfv ../../lib/`readlink $(ROOT)/usr/lib/libncursesw.so` \
		$(ROOT)/usr/lib/libncursesw.so && \
	for lib in ncurses form panel menu; do \
		rm -vf $(ROOT)/usr/lib/lib$${lib}.so && \
		echo "INPUT(-l$${lib}w)" > $(ROOT)/usr/lib/lib$${lib}.so && \
		ln -sfv lib$${lib}w.a $(ROOT)/usr/lib/lib$${lib}.a; \
	done && \
	ln -sfv libncurses++w.a $(ROOT)/usr/lib/libncurses++.a && \
	rm -vf $(ROOT)/usr/lib/libcursesw.so && \
	echo "INPUT(-lncursesw)" > $(ROOT)/usr/lib/libcursesw.so && \
	ln -sfv libncurses.so $(ROOT)/usr/lib/libcurses.so && \
	ln -sfv libncursesw.a $(ROOT)/usr/lib/libcursesw.a && \
	ln -sfv libncurses.a $(ROOT)/usr/lib/libcurses.a

	@install -v -d $(DEV)/SL && \
	install -v -d $(DEVROOT) && \
	install -v -d -m 755 $(DEVROOT)/usr/share/doc/ncurses && \
	for file in `find $(ROOT)|egrep 'man3\/|pkgconfig\/|\.a$$|\.h$$'`; do \
		path=`dirname $$file|sed "s[$(ROOT)[$(DEVROOT)["`; \
		mkdir -p $$path; \
		mv $$file $$path; \
	done && \
	cp -v -R $(SRCDIR)/doc/* $(DEVROOT)/usr/share/doc/ncurses && \
	find $(ROOT) -type d -empty -delete && \
	cd $(DEV) && make -f ../Makefile.ncurses-dev && mv *.slp ../

clean:
	@rm -rvf $(ROOT) \
		$(DEV) \
		$(SLINFO) \
		$(MANIFEST) \
		$(FILES) \
		$(SRCDIR)

